/*
htop
(C) 2004 Hisham H. Muhammad
Released under the GNU GPL, see the COPYING file
in the source distribution for its full text.
*/

#include "CRT.h"

#include <curses.h>
#include <signal.h>
#include <stdlib.h>

#define WHITE_PAIR 0
#define BLUE_PAIR 1
#define GREEN_PAIR 2
#define RED_PAIR 3
#define BROWN_PAIR 4
#define INV_PAIR 5
#define BLACK_PAIR 6

#define MIN_UPDATE_SLICE 10

//#link curses

void CRT_init() {
   initscr();
   noecho();
   halfdelay(MIN_UPDATE_SLICE);
   nonl();
   intrflush(stdscr, FALSE);
   keypad(stdscr, TRUE);
   curs_set(0);
   start_color();
//   signal(11, CRT_handleSIGSEGV);
   init_pair(BLUE_PAIR, COLOR_BLUE, COLOR_BLACK);
   init_pair(GREEN_PAIR, COLOR_GREEN, COLOR_BLACK);
   init_pair(RED_PAIR, COLOR_RED, COLOR_BLACK);
   init_pair(BROWN_PAIR, COLOR_YELLOW, COLOR_BLACK);
   init_pair(INV_PAIR, COLOR_BLACK, COLOR_GREEN);
   init_pair(BLACK_PAIR, COLOR_BLACK, COLOR_BLACK);
}

void CRT_done() {
   curs_set(1);
   endwin();
}

int CRT_readKey() {
   nocbreak();
   cbreak();
   int ret = getch();
   halfdelay(MIN_UPDATE_SLICE);
   return ret;
}

void CRT_handleSIGSEGV(int signal) {
   CRT_done();
   exit(1);
}
